# include <stdio.h>
# include <stdlib.h>
# include "board.h"

# define START 12
# define SLUT 87

# define TRUE 1
# define FALSE 0

// Vrde p olika stllningnar eller pjser
# define PJAS 30									// vrde p en enkel pjs.
# define KING 100									// vrde p en kung.
# define KANT 15				// kung p en kant
# define HORN 30				// kung i ett hrn



int board_eval(struct ch_board *board)
{
	
    int vit=0, svart=0, i = START, check = 1, bordet[32];
    int counter=0;
    int value[32]={	   // array fr vrdet p planen (frn svart sida)
		30, 30, 30, 20,
			0, 10, 10, 10,
			10, 10, 10, 0,
			0, 20, 20, 20,
			20, 20, 20, 10,
			20, 30, 30, 30,
			40, 40, 40, 30,
			20, 30, 30, 30 
    };
	//int doghole[4] = {3, 0, 0, 0};
	
	
	// bilda ett innre brde fr eval
	while(check) {		
		bordet[counter] = board->square[i];
		
		i += 2;
		counter++;
		
		if(i==20 || i==40 || i==60 || i==80)
			i += 1;
		if(i==29 || i==49 || i==69)
			i += 3;
		if(i==SLUT+2)
			check = 0;
	}
	
	check = 1;
	
	// rkna pjserna och pongstt dem
	for(i=0; i<32; i++) {		
		if(bordet[i]==B_WHITE)
			vit += PJAS;
		if(bordet[i]==B_BLACK)
			svart += PJAS;
		if(bordet[i]==B_WKING)
			vit += KING;
		if(bordet[i]==B_BKING)
			svart += KING;
	}
	
	/* pong efter var pjserna str p brdet. Kung fr ingen extra pong p brdet */
	for(i=0, counter=0; i<32; i++, counter++) {
		if(bordet[i]==B_WHITE)
			vit += value[31-counter];
		if(bordet[i]==B_BLACK)
			svart += value[counter];
	/*	if(bordet[i]==B_WKING)
			vit += 50;
		if(bordet[i]==B_BKING)
			svart += 50; */
	}
	
	/* kolla om det str en kung i ett hrn eller p kanten, i s fall mindre pong */
	for(i=0; i<3; i++) {
		if(bordet[i] == B_BKING)		// utmed kanten (uppe och nere), ej hrn
			svart -= KANT;
		if(bordet[i] == B_WKING)
			vit -= KANT;
		if(bordet[i+29] == B_BKING)
			svart -= KANT;
		if(bordet[i+29] == B_WKING)
			vit -= KANT;
	}
	for(i=4; i<21; i +=8) {				// utmed kanten (utmed sidorna)
		if(bordet[i] == B_BKING)
			svart -= KANT;
		if(bordet[i+7] == B_BKING)
			svart -= KANT;
		if(bordet[i] == B_WKING)
			vit -= KANT;
		if(bordet[i+7] == B_WKING)
			vit -= KANT;
	}
	if(bordet[3] == B_BKING)			// i ett hrn
		svart -= HORN;
	if(bordet[28] == B_BKING)
		svart -= HORN;
	if(bordet[3] == B_WKING)
		vit -= HORN;
	if(bordet[28] == B_WKING)
		vit -= HORN;
	
	
		/* komentear bort, har inte funken hr !!!
		
		  /* vinst? 
		  if (board_iswin(board, TRUE)) svart += 1000;
		  else if (board_iswin(board, FALSE)) vit += 1000;
		  
	/* om man vet vad man spelar (svart eller vit)  */
	if(board -> isblack)
		return svart-vit;
	else
		return vit-svart;
	}