/* sakans koll fr vem som det spelas fr */

# include <stdio.h>
# include <stdlib.h>
# include <limits.h>
# include "main.h"
# include "board.h"

# define SLUT 87
# define START 12

# define CHECKER 120
# define POS 1
# define KING 200
# define KINGHORN 40	// kung i ett hrn (EDGE + 40)
# define TOMOVE 10
# define MOVE 5
# define KINGMOVE 7
# define MAXDIST 16
# define RANDFACTOR 8.0

int board_eval(struct ch_board *bord, int black)
{
    int vit = 0, svart = 0, i;
    int rnd = 1+(int) (RANDFACTOR*rand()/(RAND_MAX+1.0));
    int w_pos[16], b_pos[16], b_num = 0, w_num = 0;
    int igj[32] = {
	7,7,7,7,
	0,0,0,0,
	0,20,20,0,
	0,20,30,0,
	5,30,20,5,
	19,34,34,24,
	40,40,40,38,
	0,0,0,0
    };
    int kingp[] = {
	  0,   0,   0,   0,
      -5,   5,   5,   5,
	  5,  15,  15, -5,
      -5,  15,  25,   5,
	  5,  25,  15,  -5,
      -5,   5,   5,   5,
	  5,   5,   5,  -5,
        0,   0,   0,   0
    };

    /* Pjs vrde */
    for(i = 0; i < 32; i++) {			
	if(bord->square[board_pos[i]] == B_WHITE) {
	    w_pos[w_num++] = board_pos[i];
	    vit += CHECKER;
	    vit += igj[31-i];
	    if (bord->square[board_pos[i] - 9] == B_EMPTY)
		if (!IS_BLACK(bord->square[board_pos[i] - 18])
		    && !IS_BLACK(bord->square[board_pos[i] - 20]))
		    vit += MOVE;    
	    if (bord->square[board_pos[i] - 11] == B_EMPTY)
		if (!IS_BLACK(bord->square[board_pos[i] - 22])
		    && !IS_BLACK(bord->square[board_pos[i] - 20]))
		    vit += MOVE;
	}
	else if(bord->square[board_pos[i]] == B_BLACK) {
	    b_pos[b_num++] = board_pos[i];
	    svart += CHECKER;
	    svart += igj[i];
	    if (bord->square[board_pos[i] + 9] == B_EMPTY)
                if (!IS_WHITE(bord->square[board_pos[i] + 18])
                    && !IS_WHITE(bord->square[board_pos[i] + 20]))
		    svart += MOVE;
            if (bord->square[board_pos[i] + 11] == B_EMPTY)
		if (!IS_WHITE(bord->square[board_pos[i] + 22])
		    && !IS_WHITE(bord->square[board_pos[i] + 20]))
		    svart += MOVE;
	}
	else if(bord->square[board_pos[i]] == B_WKING) {	
	    vit += KING;
	    vit += kingp[31-i];
	    w_pos[w_num++] = board_pos[i];
	    if(i == 3 || i == 28)
                vit -= KINGHORN;
	    if (bord->square[board_pos[i] - 9] == B_EMPTY)
		if (!IS_BLACK(bord->square[board_pos[i] - 18])
                    && !IS_BLACK(bord->square[board_pos[i] - 20]))
		    vit += KINGMOVE;
            if (bord->square[board_pos[i] - 11] == B_EMPTY)
                if (!IS_BLACK(bord->square[board_pos[i] - 22])
                    && !IS_BLACK(bord->square[board_pos[i] - 20]))
		    vit += KINGMOVE;
            if (bord->square[board_pos[i] + 9] == B_EMPTY)
                if (!IS_BLACK(bord->square[board_pos[i] + 18])
                    && !IS_BLACK(bord->square[board_pos[i] + 20]))
		    vit += KINGMOVE;
            if (bord->square[board_pos[i] + 11] == B_EMPTY)
                if (!IS_BLACK(bord->square[board_pos[i] + 22])
                    && !IS_BLACK(bord->square[board_pos[i] + 20]))
		    vit += KINGMOVE;
	}
	else if(bord->square[board_pos[i]] == B_BKING) {
	    svart += KING;
	    svart += kingp[i];
	    b_pos[b_num++] = board_pos[i];
	    if(i == 3 || i == 28)
		svart -= KINGHORN;
	    if (bord->square[board_pos[i] - 9] == B_EMPTY)
		if (!IS_WHITE(bord->square[board_pos[i] - 18])
                    && !IS_WHITE(bord->square[board_pos[i] - 20]))
		    svart += KINGMOVE;
            if (bord->square[board_pos[i] - 11] == B_EMPTY)
                if (!IS_WHITE(bord->square[board_pos[i] - 22])
                    && !IS_WHITE(bord->square[board_pos[i] - 20]))
		    svart += KINGMOVE;
            if (bord->square[board_pos[i] + 9] == B_EMPTY)
                if (!IS_WHITE(bord->square[board_pos[i] + 18])
                    && !IS_WHITE(bord->square[board_pos[i] + 20]))
		    svart += KINGMOVE;
            if (bord->square[board_pos[i] + 11] == B_EMPTY)
                if (!IS_WHITE(bord->square[board_pos[i] + 22])
                    && !IS_WHITE(bord->square[board_pos[i] + 20]))
		    svart += KINGMOVE;
	}
    }

    if (black)
	svart += TOMOVE;
    else
	vit += TOMOVE;

    if (board_iswin(bord, 0))
	vit += 1000;
    else if (board_iswin(bord, 1))
	svart += 1000;

    if (bord->isblack)
	return svart-vit + rnd;
    else
	return vit-svart + rnd;
}





