/*
 * Main include file for the program
 * Contains stuff that could be useful
 */

#ifndef __MAIN_H__
#define __MAIN_H__

#include <stdio.h>
#include <stdarg.h>
#include "ui.h"

#define TRUE 1
#define FALSE 0

#define INF (INT_MAX - 3)

#ifdef DEBUG
static void debug(char *s, ...)
{
    static char buf[1024];
    va_list alist;

    va_start(alist, s);

    vsnprintf(buf, 1024, s, alist);
    ui_infomsg("DEBUG: ");
    ui_infomsg(buf);
    ui_infomsg("\n");

    va_end(alist);
}
#else
 #define debug(...)
#endif

#endif /* __MAIN_H__ */
