#ifndef __BOARD_H__
#define __BOARD_H__

/* Marker types for the board.
 * These are bit-masks. Mostly.
 * DON'T FUCK WITH THEM unless you 
 * know what you are doing */
#define B_INVAL -1
#define B_CMASK 2

#define B_EMPTY 0
#define B_WHITE 1
#define B_BLACK 3
#define B_KING  4
#define B_WKING 5
#define B_BKING 7

#define IS_WHITE(n) ((n) == B_WKING || (n) == B_WHITE)
#define IS_BLACK(n) ((n) == B_BKING || (n) == B_BLACK)

#define B_START 12
#define B_END 89

static int board_pos[] = { 
    12, 14, 16, 18, 21, 23, 25, 27, 32, 34, 36, 
    38, 41, 43, 45, 47, 52, 54, 56, 58, 61, 63, 
    65, 67, 72, 74, 76, 78, 81, 83, 85, 87 
};

/* NOTE: This needs a struct ch_board-definition */
struct ch_board {
    int total_time;
    float elapsed_time;
    int square[100]; /* an array from 1-100 containing what is on the board */
    int my_moves; /* nr of moves */
    int op_moves;
    int isblack; /* True if computer == black */
};

void board_clone(struct ch_board *, struct ch_board *);
/* NOTE: Must accept null-pointer! */
void board_free(struct ch_board *);
struct ch_board *board_init();
int board_eval(struct ch_board *, int);
int board_iswin(struct ch_board *, int);
void board_clear(struct ch_board *);

#endif
